var app = {
    debug: false,
    templates: {},
    mainContainer: null,
    imageIds: null,
    imageFolders: null,
    selectionNum: 0,
    selectionArr: [],
    collectionView: null,
    uploadFiles: [],
    uploadingInfo: {},
    timerHandle: 0,
    timerCount: 0,
    mode: "image", // 模式 'image','video','music','download','files'
    submode: "images",
    folderIndex: 0,
    paths:[],
    folderStack:[],
    currentFolder: null,
    scrollTopStack: [],
    initTemplate: function() {
        $('script[type="text/x-handlebars-template"]').each(function() {
            html = $(this).html();
            name = $(this).attr("id");
            app.templates[name] = Handlebars.compile(html);
        });

    },
    generateShortId: function() {
        return ("0000" + (Math.random()*Math.pow(36,4) << 0).toString(36)).slice(-4);
    },
    loadNavbar: function(){
        $.ajax({
            url: '/static/html/inc/navbar.html',
            success: function(res) {
                var template = Handlebars.compile(res);
                var html = template();
                $('.right-container').prepend(html);
            }
        })
    },
    render:function(ele, source, data) {
        template = Handlebars.compile(source);
        $(ele).html(template(data));
    },
    loadImages: function() {
        if (app.imageIds) {
            var html = app.templates['template-images']({imageIds: app.imageIds});
            app.mainContainer.html(html);
        }
        $.getJSON('/images/list', function(res){
            console.log("res code " + res["code"]);
            console.log(res);
            if (res["code"] == 0) {
                app.imageIds = res.imageIds;
                console.log("render images");
                var html = app.templates['template-images'](res);
                app.mainContainer.removeClass('has-breadcrumb');
                app.mainContainer.html(html);
            }
        });
        
    },
    /// 加载照片文件夹
    loadImageFolders: function() {
        app.paths = [];
        app.paths.push('全部相册');
        if (app.imageFolders) {
            var html = app.templates['template-image-folders']({folders: app.imageFolders});
            app.mainContainer.html(html);
            var breadcrumb = app.templates['template-breadcrumb'](app.paths);
            app.mainContainer.prepend(breadcrumb);
        }
        $.getJSON('/images/folders', function(res){
            console.log("res code " + res["code"]);
            console.log(res);
            if (res["code"] == 0) {
                app.imageFolders = res.folders;
                console.log("render folders");
                var html = app.templates['template-image-folders'](res);
                app.mainContainer.html(html);
                app.mainContainer.addClass('has-breadcrumb');
                console.log(app.paths);
                var breadcrumb = app.templates['template-breadcrumb'](app.paths);
                app.mainContainer.prepend(breadcrumb);
            }
        });
    },
    loadFiles: function(path) {
        $.getJSON('/path', {
            path: path
        },function(res){
            console.log("res code " + res["code"]);
            console.log(res);
            if (res["code"] == 0) {
                app.currentFolder = res;
                var paths = res.path.split('/');
                if (!paths) {
                    app.paths = "Root";
                } else {
                    app.paths = paths;
                    if (!app.paths[0]) {
                        app.paths[0] = "Root";
                    }
                }
                var html = app.templates['template-folders'](res);
                var breadcrumb = app.templates['template-breadcrumb'](app.paths);
                app.mainContainer.addClass('has-breadcrumb');
                app.mainContainer.html(html);
                app.mainContainer.prepend(breadcrumb);
                document.getElementById('main-container').scrollTop = app.preScrollTop;
                console.log(app.preScrollTop);
            }
        });
    },
    loadVideos: function(path) {
        app.mainContainer.removeClass('has-breadcrumb');
        var data = {};
        if (path) {
            data.path = path;
            app.paths = ["Root", app.currentFolder.name];
            console.log('app paths');
            console.log(app.currentFolder);
            console.log(app.paths);
        }
        $.getJSON('/videos',data, function(res) {
            console.log(res);
            if (res["code"] == 0) {
                app.currentFolder = res;
                var html = app.templates['template-video'](res);
                app.mainContainer.html(html);
                if (path) {
                    app.mainContainer.addClass('has-breadcrumb');
                    var breadcrumb = app.templates['template-breadcrumb'](app.paths);
                    app.mainContainer.prepend(breadcrumb);
                }
            } else {
                app.mainContainer.html("<h1>没有视频</h1>");
            }
        });
    },
    loadVideoFolders: function() {
        $.getJSON('/video/folders', function(res) {
            console.log(res);
            if (res["code"] == 0) {
                app.currentFolder = res;
                var html = app.templates['template-video-folders'](res);
                app.mainContainer.html(html);
            }
        });
    },
    loadMusicList: function(path) {
        var data = {};
        if (path) {

        }
        $.getJSON('/musics',data, function(res) {
            console.log(res);
            if (res["code"] == 0) {
                app.currentFolder = res;
                var html = app.templates['template-music-list-table'](res);
                app.mainContainer.html(html);
                if (path) {
                    app.mainContainer.addClass('has-breadcrumb');
                    var breadcrumb = app.templates['template-breadcrumb'](app.paths);
                    app.mainContainer.prepend(breadcrumb);
                }
            } else {
                app.mainContainer.html("<h1>没有音乐</h1>");
            }
        });
    },
    isSelectImageId: function(imageId) {
        for (var i = 0; i < app.selectionArr.length; i++) {
            if (app.selectionArr[i] == imageId) {
                return true;
            }
        }
        return false;
    },
    imageCellClick: function(imageId) {
        console.log("click " + imageId);
        if ($('body').hasClass('selection-mod')) {
            app.checkCell(imageId);
            return;
        }
        var html = app.templates["template-preview"](imageId);
        $('body').append(html);
    },
    closePreview: function() {
        $('.image-preview-container').remove();
    },
    checkCell: function(id) {
        if (app.mode == 'image') {
            var imageId = id;
            console.log('checkCell ' + imageId);
            var cell = $("#cell-id-"+imageId);
            // $("i", cell).toggleClass('checked');
            cell.toggleClass('selection');
            if (cell.hasClass('selection')) {
                app.selectionNum += 1;
                app.selectionArr.push(imageId);
            } else {
                app.selectionNum -= 1;
                for (var i = 0; i < app.selectionArr.length; i++) {
                    if (app.selectionArr[i] == imageId) {
                        app.selectionArr.splice(i, 1);
                        break;
                    }
                }
            }
        } else if (app.mode == 'files') {
            console.log('checkCell ' + id);
            var cell = $("#folder-id-" + id);
            cell.toggleClass('selection');
            if (cell.hasClass('selection')) {
                app.selectionNum += 1;
                app.selectionArr.push(id);
            } else {
                app.selectionNum -= 1;
                for (var i = 0; i < app.selectionArr.length; i++) {
                    if (app.selectionArr[i] == id) {
                        app.selectionArr.splice(i, 1);
                        break;
                    }
                }
            }
        } else if (app.mode == 'video') {
            var cell = $("#cell-id-" + id);
            cell.toggleClass('selection');
            if (cell.hasClass('selection')) {
                app.selectionNum += 1;
                app.selectionArr.push(id);
            } else {
                app.selectionNum -= 1;
                for (var i = 0; i < app.selectionArr.length; i++) {
                    if (app.selectionArr[i] == id) {
                        app.selectionArr.splice(i, 1);
                        break;
                    }
                }
            }
        } else if (app.mode == 'music') {
            var cell = $("#cell-id-" + id);
            cell.toggleClass('selection');
            if (cell.hasClass('selection')) {
                app.selectionNum += 1;
                app.selectionArr.push(id);
            } else {
                app.selectionNum -= 1;
                for (var i = 0; i < app.selectionArr.length; i++) {
                    if (app.selectionArr[i] == id) {
                        app.selectionArr.splice(i, 1);
                        break;
                    }
                }
            }
        }
        $('#nav-download').text("下载(" + app.selectionNum + ")");
        if (app.selectionNum >0 ) {
            if (!$('body').hasClass('selection-mod')) {
                $('body').addClass('selection-mod');
            }
        } else {
            $('body').removeClass('selection-mod');
        }
    },
    selectAll: function() {
        app.selectionArr = [];
        if (app.mode == 'image') {
            if (app.submode == 'images') {
                for (var i = 0; i < app.imageIds.length; i++) {
                    app.selectionArr.push(app.imageIds[i]);
                }
            } else {
                var arr = app.imageFolders[app.folderIndex].imageIds;
                for (var i = 0; i < arr.length; i++) {
                    app.selectionArr.push(arr[i]);
                }
            }
        } else if (app.mode == 'video') {
            if ($('.image-folder-cell').length == 0) {
                console.log('videos');
                // app.selectionArr.push(1);
                // app.selectionArr.push(2);
                for (var i = 0; i < app.currentFolder.videoList.length; i++) {
                    app.selectionArr.push(i);
                }
            } else {
                console.log('video folder');
                for (var i = 0; i < app.currentFolder.children.length; i++) {
                    app.selectionArr.push(i);
                }
            }
        } else if (app.mode == 'music') {
            $('.music-list input').prop('checked', true);
            $('.music-list input').addClass('selection');
            for (var i = 0; i < app.currentFolder.children.length; i++) {
                app.selectionArr.push(i);
            }
        }
        
        app.selectionNum = app.selectionArr.length;
        $('.image-cell').addClass('selection');
        $('body').addClass('selection-mod');
        $('#nav-download').text("下载(" + app.selectionNum + ")");
    },
    cancelSelection: function() {
        app.selectionArr = [];
        app.selectionNum = app.selectionArr.length;
        $('.image-cell').removeClass('selection');
        $('body').removeClass('selection-mod');
        if (app.mode == 'music') {
            $('.music-list input').prop('checked', false);
            $('.music-list input').removeClass('selection');
        }
    },
    downloadSelected: function() {
        if (app.mode == 'image') {
            var folderCells = $('.image-folder-cell');
            if (folderCells.length == 0) {
                console.log('downloadSelectedImage');
                console.log(app.selectionArr);
                var data = {
                    "imageIds": app.selectionArr
                };
                var dataStr = JSON.stringify(data);
                $.ajax({
                    url: '/images/download',
                    type: 'POST',
                    dataType: 'json',
                    contentType: 'application/json',
                    data: dataStr,
                    success: function(res) {
                        console.log('download return');
                        console.log(res);
                        if (res.code == 0) {
                            window.location.href = "/images/download?id="+res.id;
                        }
                    }
                });
            } else { // 下载文件夹压缩包
                var downloadFolder = [];
                for (var i = 0; i < app.selectionArr.length; i++) {
                    downloadFolder.push(app.imageFolders[app.selectionArr[i]].folderName);
                }
                var dataStr = JSON.stringify(downloadFolder);
                console.log(dataStr);
                $.ajax({
                    url: '/images/folder/download',
                    type: 'POST',
                    dataType: 'json',
                    contentType: 'application/json',
                    data: dataStr,
                    success: function(res) {
                        console.log('download return');
                        console.log(res);
                        if (res.code == 0) {
                            window.location.href = "/images/folder/download?id="+res.id;
                        }
                    }
                });
            }
        } else if (app.mode == 'files' || app.mode == 'music') {
            var paths = [];
            for (var i = 0; i < app.selectionArr.length; i++) {
                paths.push(app.currentFolder.children[app.selectionArr[i]].absoultePath);
            }
            var data = {
                paths: paths,
                basePath: app.currentFolder.absoultePath
            }
            var dataStr = JSON.stringify(data);
            $.ajax({
                'url': '/file/download',
                'type': 'POST',
                'dataType': 'json',
                'contentType': 'application/json',
                data: dataStr,
                success: function(res) {
                    console.log('download file return');
                    console.log(res);
                    if (res.code == 0) {
                        window.location.href = '/file/download?id=' + res.id;
                    }
                }
            });
        } else if (app.mode == 'video') {
            var paths = [];
            for (var i = 0; i < app.selectionArr.length; i++) {
                var index = app.selectionArr[i];
                if (app.submode == 'videos') {
                    paths.push(app.currentFolder.videoList[index].absoultePath);
                } else {
                    paths.push(app.currentFolder.children[index].absoultePath);
                }
            }
            var data = {
                paths: paths,
                type: "video"
            }
            var dataStr = JSON.stringify(data);
            $.ajax({
                'url': '/file/download',
                'type': 'POST',
                'dataType': 'json',
                'contentType': 'application/json',
                data: dataStr,
                success: function(res) {
                    console.log('download file return');
                    console.log(res);
                    if (res.code == 0) {
                        window.location.href = '/file/download?id=' + res.id;
                    }
                }
            });
        }
        
    },
    filechanged: function() {
        console.log('filechanged');
        $('#upload-modal').modal({'backdrop': 'static', 'show': false});
        $('.uploading').show();
        $('.upload-finish').hide();
        $('#upload-cancel').show();
        $('#upload-finish').hide();
        $('#upload-modal').modal('show');
        // $('.file-submit').click();
        var files = $('#files')[0].files;
        app.uploadingInfo = {
            uploadedSize: 0,
            totalSize: 0,
            uploadingName: "",
            fileNum: 0,
            uploadedNum: 0,
            speed: 0
        };
        app.uploadingInfo.fileNum = files.length;
        for (var i = 0; i < files.length; i++) {
            app.uploadFiles.push(files[i]);
            // app.uploadingInfo.totalSize += files[i].size;
        }
        $('#files').val("");
        app.updateUploadDialog();
        app.nextFile();
        // 定时器检查速度
        app.timerCount = 0;
        app.timerHandle = setInterval(app.checkSpeed, 1000);
    },
    nextFile: function() {
        if (app.uploadFiles.length > 0) {
            var file = app.uploadFiles[0];
            app.uploadFiles.splice(0,1);
            if (file) {
                var size = file.size;
                if (size > 1024 * 1024) {
                    size = (Math.round(file.size * 100 / (1024 * 1024)) / 100).toString() + 'MB';
                } else {
                    size = (Math.round(file.size * 100 / 1024) / 100).toString() + 'KB';
                }
                app.uploadFile(file);
            }
        } else {
            // 上传完成
            // app.uploadFinish();
        }
    },
    uploadFile:function(file) {
        app.uploadingInfo.uploadingName = file.name;
        app.uploadingInfo.uploadedSize = 0;
        var xhr = new XMLHttpRequest();
        var fd = new FormData();
        console.log(app.currentFolder);
        if (app.currentFolder && app.currentFolder.absoultePath) {
            fd.append('path', app.currentFolder.absoultePath);
        }
        fd.append('files', file, encodeURIComponent(file.name));
        // var fd = new FormData(document.getElementById('upload-form'));

        xhr.upload.addEventListener('progress', function(event) {
            if (event.lengthComputable) {
                console.log(event);
                console.log('uploaded: ' + event.loaded + ' total: ' + event.total);
                app.uploadingInfo.uploadedSize = event.loaded;
                app.uploadingInfo.totalSize = event.total;
                if (event.loaded === event.total) {
                    // 上传完成
                    console.log('upload completed');
                    app.uploadingInfo.uploadedNum += 1;
                    app.timerCount = 0;
                    app.nextFile();
                }
                app.updateUploadDialog();
            }
        }, false);

        xhr.open('POST','/fileupload');
        xhr.onreadystatechange = function() {
            if (xhr.readyState == XMLHttpRequest.DONE) {
                if (xhr.status == 200) {
                    var json = xhr.responseText;
                    var res = JSON.parse(json);
                    console.log(res);
                    app.uploadFinish(res);
                }
            }
        }
        xhr.send(fd);

        $('#upload-modal').on('hide.bs.modal', function(event) {
            xhr.abort();
        });
    },
    updateUploadDialog: function() {
        console.log(app.uploadingInfo);
        if (app.uploadingInfo.uploadedNum == app.uploadingInfo.total) {
            $('#upload-modal').modal('hide');
        }
        $(".uploading-name").text('正在上传: ' + app.uploadingInfo.uploadingName);
        $(".upload-num").text('已上传: ' + app.uploadingInfo.uploadedNum + " 共: " + app.uploadingInfo.fileNum);
        var percent = Math.round(app.uploadingInfo.uploadedSize / app.uploadingInfo.totalSize * 100);
        $(".progress-bar").css('width', percent + "%");
        $(".upload-speed").text("速度: " + app.uploadingInfo.speed);
    },
    uploadFinish: function(msg) {
        clearInterval(app.timerHandle);
        app.timerHandle = 0;
        $('.uploading').hide();
        console.log($('.location'));
        $('.location').html(msg.message);
        $('.upload-finish').show();
        $('#upload-cancel').hide();
        $('#upload-finish').show();

        if (app.mode == 'images') {
            if (app.submode == 'image') {
                app.loadImages();
            } else {
                app.loadImageFolders();
            }
        } else if (app.mode == 'files') {
            console.log('reload files');
            app.loadFiles(app.currentFolder.absoultePath);
        } else if (app.mode == 'video' && app.mode == 'folders') {
            console.log('reload video');
            if (app.currentFolder && app.currentFolder.absoultePath) {
               app.loadVideos(app.currentFolder.absoultePath);
            }
        }
    },
    checkSpeed: function() {
        app.timerCount += 1;
        var speed = app.uploadingInfo.uploadedSize / app.timerCount;
        if (speed > 1024 * 1024) {
            speed = (Math.round(speed *100 / (1024 * 1024)) / 100).toString() + " MB/s";
        } else {
            speed = (Math.round(speed * 100 / 1024) / 100).toString() + " KB/s";
        }
        app.uploadingInfo.speed = speed;
    },
    selectNavItem: function(ele,index) {
        $('#sidebar-page li').removeClass('active');
        $(ele).parent().addClass('active');
        if (index == 0) {
            app.setMode('image');
        } else if (index == 1) {
            app.setMode('video');
        } else if (index == 2) {
            app.setMode('music');
        } else if (index == 3) {
            app.setMode('download');
        } else if (index == 4) {
            app.setMode('files');
        }
    },
    /// 切换模式
    setMode:function(mode) {
        console.log('setMode ' + mode);
        $('#toolbar .btn-group').remove();
        app.mode = mode;
        app.currentFolder = null;
        if (mode == 'image') {
            app.submode = 'images';
            app.loadImages();
            $('#toolbar').prepend(app.templates['template-image-tools']())
        } else if (mode == 'video') {
            app.submode = 'videos';
            app.loadVideos();
            $('#toolbar').prepend(app.templates['template-video-tools']())
        } else if (mode == 'music') {
            app.loadMusicList();
        } else if (mode == 'download') {
            app.loadFiles('/download');
        } else if (mode == 'files') {
            app.loadFiles('/');
        }

        app.cancelSelection();
    },
    setSubmode: function(submode, ele) {
        app.submode = submode;
        if (app.mode == 'image') {
            if (submode == 'images') {
                app.loadImages();
            } else if (submode == 'folders') {
                app.loadImageFolders();
            }
        } else if (app.mode == 'video') {
            if (submode == 'videos') {
                app.loadVideos();
            } else if (submode == 'folders') {
                app.loadVideoFolders();
            }
        }
        if (ele) {
            $('.btn-group button').removeClass('active');
            $(ele).addClass('active');
        }
        app.cancelSelection();
    },
    clickImageFolder: function(index, ele) {
        console.log('clickImageFolder');
        console.log(app.imageFolders[index]);
        if ($('body').hasClass('selection-mod')) {
            app.checkCell(index);
            return;
        }

        app.folderStack.push(index);
        app.folderIndex = index;
        app.paths.push(app.imageFolders[index].folderName);
        app.currentFolder = app.imageFolders[index];
        var html = app.templates['template-images'](app.imageFolders[index]);
        app.mainContainer.html(html);
        var breadcrumb = app.templates['template-breadcrumb'](app.paths);
        app.mainContainer.prepend(breadcrumb);
    },
    clickBreadcrumb: function(index) {
        console.log('clickBreadcrumb index ' + index);

        if (app.mode == 'image') {
            var pathLen = app.paths.length || 0;
            if (index == 0) {
                app.loadImageFolders();
            }
            else if (index < pathLen) {
                var i = app.folderStack[index-1];
                app.folderStack.splice(index, app.folderStack.length - (index-1));
                app.paths.splice(index+1, pathLen - (index-1));
                app.clickImageFolder(i);
            }
        } else if (app.mode == 'files' || app.mode == 'download') {
            var rootPath = app.currentFolder.rootPath;
            if (rootPath[rootPath.length-1] != '/') {
                rootPath += '/';
            }
            var path = "";
            for (var i = 1; i <= index; i++) {
                path += app.paths[i];
                if (i < index) {
                    path += '/';
                }
            }
            app.loadFiles(rootPath + path);
        } else if (app.mode == 'video') {
            app.loadVideoFolders();
            app.mainContainer.removeClass('has-breadcrumb');
        }
    },
    clickFolder: function(index, ele) {
        if ($('body').hasClass('selection-mod')) {
            app.checkCell(index);
            return;
        }
        var child = app.currentFolder.children[index];
        if (child && child.isFolder) {
            app.preScrollTop = document.getElementById('main-container').scrollTop; // 滚动高度
            app.loadFiles(child.absoultePath);
        } else {
            var href = "/file?path=" + encodeURIComponent(child.absoultePath);
            var hideA = '<a id="filedownload" target="_blank" href="' + href +'" style="display:none;">文件下载</a>';
            $('body').append(hideA);

            setTimeout(function(){
                console.log('click filedownload');
                document.getElementById('filedownload').click();
                $('#filedownload').remove();
            }, 500);
        }
    },
    videoClick: function(index) {
        if ($('body').hasClass('selection-mod')) {
            app.checkCell(index);
            return;
        }
        var path = app.currentFolder.videoList[index].absoultePath;
        app.openInNewTab("/file?path=" + encodeURIComponent(path));
    },
    openInNewTab:function(href) {
        var hideA = '<a id="filedownload" target="_blank" href="' + href +'" style="display:none;">文件下载</a>';
        $('body').append(hideA);

        setTimeout(function(){
            console.log('click filedownload');
            document.getElementById('filedownload').click();
            $('#filedownload').remove();
        }, 500);
    },
    clickVideoFolder: function(index) {
        var folder = app.currentFolder.children[index];
        app.currentFolder = folder;
        app.loadVideos(folder.absoultePath);
    }
}

function registerHelper() {
    console.log('registerHelper');
    Handlebars.registerHelper('first', function(arr) {
        return arr[0];
    });
    Handlebars.registerHelper('isLastPath', function(index, options) {
        console.log('isLastPath')
        console.log(index);
        if (index == app.paths.length-1) {
            console.log('last');
            return options.fn(this);
        } else {
            return options.inverse(this);
            console.log('not last');
        }
    });
    // 把长的文件名缩短
    Handlebars.registerHelper('minFileName', function(name) {
        if (name.length > 20) {
            var first = name.substring(0, 8);
            var last = name.substring(name.length-8, name.length);
            return first + "..." + last;
        } else {
            return name;
        }
    });
    // 通过文件扩展名显示对应的图标
    Handlebars.registerHelper('iconForExtName', function(name) {
        var arr = name.split('.');
        if (arr.length > 0) {
            var extName = arr[arr.length-1];
            console.log('extName ' + extName);
            return 'file-o';
        } else {
            return 'file-o';
        }
    });
    // 编码
    Handlebars.registerHelper('encode', function(string) {
        return encodeURIComponent(string);
    });
    // 判断是否图片
    Handlebars.registerHelper('isImage', function(name, options) {
        var arr = name.split('.');
        if (arr.length > 0) {
            var extName = arr[arr.length-1].toLowerCase();
            if (extName == 'png' || extName == 'jpeg' || extName == 'jpg') {
                return options.fn(this);
            } else {
                return options.inverse(this);
            }
        } else {
            return options.inverse(this);
        }
    });
    // 把毫秒时间格式化
    Handlebars.registerHelper('formatTime', function(duration) {
        var s = duration / 1000;
        var hour = Math.floor(s / 3600);
        var minute = Math.floor((s % 3600) / 60);
        var second = Math.floor((s % 3600) % 60);
        if (hour < 10) {
            hour = "0" + hour;
        }
        if (minute < 10) {
            minute = "0" + minute;
        }
        if (second < 10) {
            second = "0" + second;
        }
        return hour + ":" + minute + ":" + second;
    });
}

$(document).ready(function(){
    // app.loadHeader();
    registerHelper();
    app.mainContainer = $("#main-container");
    app.initTemplate();
    // app.loadNavbar();
    app.setMode('image'); // 模式图片模式
});

if (!app.debug) {
    console.log = function(){};
}
