var CollectionView = function() {
    this.container = $('<div class="collection-view"></div>');
    this.container.css("width", "100%");
    this.container.css("position", "relative");
    this.cellCache = [];
    var self = this;
    window.onscroll = function() {
        console.log("onscroll");
        self.reloadData();
    }
    $(window).resize(function() {
        console.log("resize");
        self.reloadData();
    })
}
// 代理
CollectionView.prototype.delegate = null;
// 数据源
CollectionView.prototype.datasource = null;

CollectionView.prototype.html = function() {
    return this.container;
}

// 加载数据
CollectionView.prototype.reloadData = function() {
    this.container.empty();
    this.count = this.datasource.count();
    var size = this.size = this.datasource.cellSize();
    this.containerWidth = this.container.width();
    this.bodyHeight = document.body.clientHeight;
    this.scrollTop = document.body.scrollTop;
    console.log("size " + this.size.width, this.size.height);
    console.log("containerWidth " + this.containerWidth);
    console.log("bodyHeight " + this.bodyHeight);
    console.log("scrollTop " + this.scrollTop);

    // 一行多少个cell
    this.cellNumberInRow = Math.floor(this.containerWidth / size.width);
    var containerHeight = (this.count / this.cellNumberInRow) * size.height;
    this.container.css("height", containerHeight);

    this.left = (this.containerWidth - this.cellNumberInRow * size.width) / 2;
    console.log("left " + this.left);
    console.log(" " + this.cellNumberInRow * size.width);
    this.top = 0;

    var indexs = this.getRenderCellIndexs();
    console.log("indexs");
    console.log(indexs);

    for (var i = 0; i < indexs.length; i++){
        var cell = $(this.datasource.cellForIndex(indexs[i]));
        var pos = this.getPositionForCellIndex(indexs[i]);
        cell.css("position", "absolute");
        cell.css("left", pos.left);
        cell.css("top", pos.top);
        this.container.append(cell);
    }
}

/// 获取需要渲染的cell的indexs
CollectionView.prototype.getRenderCellIndexs = function() {
    var offsetTop = this.scrollTop - this.container.position().top * 10;
    // var offsetTop = -1000;
    var bottom = offsetTop + this.bodyHeight * 10;
    console.log("offsetTop " + offsetTop);
    console.log("bottom " + bottom);
    console.log("container top " + this.container.position().top);
    var indexs = [];
    var startIndex = 0;
    for (var i = 0; i < this.count; i++) {
        var pos = this.getPositionForCellIndex(i);
        console.log("pos " + pos.top);
        if (pos.top < offsetTop && pos.top + this.size.height > offsetTop) {
            indexs.push(i);
        }
        if (pos.top > offsetTop) {
            indexs.push(i);
        }
        if (pos.top > bottom) {
            break;
        }
    }
    return indexs;
}

CollectionView.prototype.getPositionForCellIndex = function(index) {
    var left = (this.containerWidth - this.cellNumberInRow * this.size.width) / 2;
    var row = Math.floor(index / this.cellNumberInRow);
    var col = index % this.cellNumberInRow;
    x = left + col * this.size.width;
    y = row * this.size.height;
    return {left: x, top: y};
}